// Learn TypeScript:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/typescript.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html

const { ccclass, property } = cc._decorator;

@ccclass
export default class scene extends cc.Component {

    @property(cc.Prefab)
    prefab: cc.Prefab = null;

    Progress:cc.ProgressBar = null;

    btn: cc.Button = null;


    // LIFE-CYCLE CALLBACKS:

    onLoad () {
        let _prefab =  cc.instantiate(this.prefab);
        this.Progress = _prefab.getChildByName('ProgressBar').getComponent(cc.ProgressBar);
        this.btn = _prefab.getChildByName('Btn').getComponent(cc.Button);
        this.node.addChild(_prefab);
    }

    start() {
        this._registerEvent();
    }

    // update (dt) {}

    btnCallBack() {
        let _num = Math.ceil(Math.random() * 10);

        this.Progress.progress = _num / 10;
        cc.log('Progress.progress >', this.Progress.progress);
    }

    _registerEvent() {
        this.btn.node.on('click', this.btnCallBack, this);
    }
}
